package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.CaixaContratoDAO;
import com.rjconsultores.ventaboletos.entidad.CaixaContrato;

@SuppressWarnings("unchecked")
@Repository("caixaContratoDAO")
public class CaixaContratoHibernateDAO extends GenericHibernateDAO<CaixaContrato, Long> implements CaixaContratoDAO {

    @Autowired
    public CaixaContratoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

	@Override
    public List<CaixaContrato> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

	@Override
	public List<CaixaContrato> buscarExtratoContrato(Long contratoId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("contratoId", contratoId));

        return c.list();
	}

	@Override
	public CaixaContrato gravarMovimento(CaixaContrato caixa) {
		return suscribir(caixa);
	}
}
